'' =================================================================================================
''
''   File....... V3 Cylon project.spin
''   Author..... Stilgar
''   Special thanks to Jon Williams, Brandon Nimon, Chip Gracey, Colin Fox

'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' 

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1     = 31
  TX1     = 30
  SDA     = 29
  SCL     = 28



  
  ' rtime1 pin 4 
  ' rtime2 pin 5 

  ' sound pin 10


con 

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control
  
_numleds = 16
_firstled = 12
maxbright = 64




obj

  rc      : "RCTime3"                                                              ' get object
  led     : "led_pwm_1"

  
var

  long  wavcog
  long  stack[32]
  long  numleds_, firstled_, persistence_, leds[_numleds]    'these must appear in this order


PUB Awakening | x, t, idx, rtime1, rtime2
  
  rc.RCTIME_forever(4, 500, 1, @rtime1)          ' start loading sweep speed rtime with current RC value
  waitcnt(clkfreq / 400 + cnt)                 ' allow a little time for rtime to get a value (may need to increase, or be able to decrease)

  rc.RCTIME_forever(5, 500, 1, @rtime2)          ' start loading persistence rtime with current RC value
  waitcnt(clkfreq / 400 + cnt)                  ' allow a little time for rtime to get a value (may need to increase, or be able to decrease)

  numleds_ := _numleds
  firstled_ := _firstled

  persistence_ := rtime2/7000

  

  led.start(@numleds_)

  repeat 

    repeat x from 7 to _numleds-8
      leds[x] := maxbright 
      waitcnt(clkfreq / (rtime1)+ cnt)              ' center LEDs slowly go from 0 to maxbright 64

    repeat x from _numleds-8 to 7
      leds[x] := maxbright       
      waitcnt(clkfreq / (rtime1)+ cnt)                   


    'repeat x from 7 to _numleds-1
     ' leds[x] := maxbright
      'waitcnt(clkfreq / (rtime1 / 1200)+ cnt)      ' maxbright remains 64 for this code and the rest of full programing

   ' repeat x from _numleds-1 to 0
     ' leds[x] := maxbright
      'waitcnt(clkfreq / (rtime1 / 1200)+ cnt)
 
 
  led.stop

